//
// Created by philipp on 04.04.18.
//

#ifndef PLATOONPROTOCOL_PROTOCOLFACADE_H
#define PLATOONPROTOCOL_PROTOCOLFACADE_H

#include <NetworkingLib/Networking.h>
#include "Vehicle.h"

namespace platoonProtocol
{

class VehicleFacade
{
public:
    explicit VehicleFacade(Vehicle::Role role, networking::Networking & net, const NetworkInfo & info);

    void reset(Vehicle::Role role, networking::Networking & net, const NetworkInfo & info);

    Vehicle::Ptr get();

    // Vehicle methods

    bool isIdle();

    bool isPlatoonRunning();

    void createPlatoon();

    void leavePlatoon();

    void stop();

    VehicleId getOwnVehicleId();

    Vehicle::Role getRole();

    void setOnRunningPlatoonCallback(const Vehicle::Callback & callback);

    void setOnLeavingPlatoonCallback(const Vehicle::Callback & callback);

    // LeaderVehicle methods

    std::size_t getNumFollowers();

    void setPlatoonConfig(const PlatoonConfig & platoonConfig);

    // FollowerVehicle methods

    PlatoonConfig getPlatoonConfig();

    void setOnPlatoonConfigUpdatedCallback(const Vehicle::Callback & callback);

private:
    Vehicle::Ptr vehicle;
    std::mutex mutex;
};

}

#endif //PLATOONPROTOCOL_PROTOCOLFACADE_H
